(***********************************************************************
 *
 * options.pas
 *
 * Copyright (c) 2016 Michel Deslierres
 * All rights reserved. Tous droits réservés.
 *
 * Read full license in the file license.txt
 * Lire la licence au complet dans le fichier license.txt
 *
 *************************************************************************)

unit Options;

{$IFDEF FPC}
  {$mode objfpc}
  {$h+ }
{$ENDIF}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type

  { TOptionsForm }

  TOptionsForm = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Edit3: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
  end;

var
  OptionsForm: TOptionsForm;

implementation

{$R *.lfm}

uses
  Math, mdMathTokenizer, mdMathEvaluator, Environment, Info, FpuExceptionsInfo;

procedure TOptionsForm.Button1Click(Sender: TObject);
var
  FPUMask: TFPUExceptionMask;
begin
  FPUMask := [exPrecision];
  if CheckBox1.Checked then include(FPUMask, exInvalidOp);
  if CheckBox2.Checked then include(FPUMask, exDenormalized);
  if CheckBox3.Checked then include(FPUMask, exZeroDivide);
  if CheckBox4.Checked then include(FPUMask, exOverflow);
  if CheckBox5.Checked then include(FPUMask, exUnderflow);
  //if CheckBox6.Checked then include(FPUMask, exPrecision);
  {$IFnDEF NO_EXCEPTION_MASK}
  MathEvaluator.ExceptionMask := FPUMask;
  {$ELSE}
  SetExceptionMask(FpuMask);
  {$ENDIF}
  MathEvaluator.RaiseExceptions := CheckBox7.Checked;
  if (Edit1.Text <> '') then begin
    if MathEvaluator.CanBeDecimalSeparator(Edit1.Text[1]) then
      MathEvaluator.DecimalSeparator := Edit1.Text[1]
    else
      MessageDlgPos(Format('"%s" cannot be a decimal separator', [Edit1.Text[1]]),
        mtInformation, [mbOk], 0, Left + 10, Top + 20);
  end;
  if ContextInfoForm.Visible then
    ContextInfoForm.RefreshInfo;
  if not CheckBox6.Checked then
    MessageDlgPos('Cannot unmask (allow) loss of precision exceptions',
      mtInformation, [mbOk], 0, Left + 10, Top + 20);
  ModalResult := mrOk;
end;

procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  {$IFnDEF NO_EXCEPTION_MASK}
  Label2.Caption := Label2.Caption + ' during evaluation';
  {$ENDIF}
end;

procedure TOptionsForm.FormShow(Sender: TObject);
var
  FPUMask: TFPUExceptionMask;
begin
  {$IFnDEF NO_EXCEPTION_MASK}
  FPUMask := MathEvaluator.ExceptionMask;
  {$ELSE}
  FPUMask := GetExceptionMask;
  {$ENDIF}
  CheckBox1.Checked := exInvalidOp in FPUMask;
  CheckBox2.Checked := exDenormalized in FPUMask;
  CheckBox3.Checked := exZeroDivide in FPUMask;
  CheckBox4.Checked := exOverflow in FPUMask;
  CheckBox5.Checked := exUnderflow in FPUMask;
  CheckBox6.Checked := exPrecision in FPUMask;

  CheckBox7.Checked := MathEvaluator.RaiseExceptions;
  Edit1.Text := MathEvaluator.DecimalSeparator;
  Label4.Caption := Format('(%s)', [DefaultFormatSettings.DecimalSeparator]);
end;

procedure TOptionsForm.BitBtn1Click(Sender: TObject);
begin
  FpuExceptionInfoForm.ShowModal;
end;

end.
