(***********************************************************************
 *
 * ParserConsts version 1.1
 *
 * Copyright (c) 2016 Michel Deslierres
 * All rights reserved. Tous droits réservés.
 *
 * Read full license in the file license.txt
 * Lire la licence au complet dans le fichier license.txt
 *
 *************************************************************************
 *
 * Changements / Changes
 *
 * - version 1.1
 *
 *     Changed SmeExpectedRightPar message to accomodate different
 *     left, right parenthesis combinations
 *
 *************************************************************************)

{: Unit with string contants for parser.}
 unit ParserConsts;

{$IFDEF FPC}
  {$mode objfpc}
  {$h+ }
{$ENDIF}

{$I parser.inc}

interface

uses
  ParserTypes;

{$IFDEF UNIT_INFO}
const
  SVersionName = 'ParserConsts';
  SVersion = '1.1';
  VersionMajor = 1;
  VersionMinor = 1;
{$ENDIF}

const
  SParseError = 'Parse error';
  SmeNoError = 'No error';
  SmeUnexpectedEOS = 'unexpected end of source';
  SmeExpectedEOS = 'expected end of source';
  SmeInvalidNumber = 'invalid number';
  SmeUnexpectedElement = 'unexpected element';
  SmeExpectedRightPar = 'expected matching right parenthesis';
  SmeOtherError = 'Error: %s';
  SmeEvalError = 'Evaluation error: %s';

  {Returns an errror message based on the specified TParserError. The
   parser's list char must also be given.}
function ParserErrorMessage(value: TParserError): string;

implementation

uses
  SysUtils;

function ParserErrorMessage(value: TParserError): string;
begin
  case value of
    meUnexpectedEOS: result := SmeUnexpectedEOS;
    meExpectedEOS: result := SmeExpectedEOS;
    meInvalidNumber: result := SmeInvalidNumber;
    meUnexpectedElement: result := SmeUnexpectedElement;
    meExpectedRightPar: result := SmeExpectedRightPar;
  else
    {$IFDEF DEBUG}
    assert(false, Format('unknown parser error #%d',[ord(value)]));
    {$ENDIF}
  end;
  result := Format('%s, %s', [sParseError, result]);
end;

end.
